// This file was generated by Dashcode from Apple Computer, Inc.
// You may edit this file to customize your Dashboard widget.

var pelicanURI = "http://www19.nittsu.co.jp/confirm/";
var widgetURI = "http://www2.atwiki.jp/macstar/pages/25.html";
var httpReq;
var lastCheckTime = 0;

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

function load()
{
	setupParts();
	
	// Placeholder ローカライズ
	var numberField = document.getElementById("numberfield");
	var placeHolder = numberField.getAttribute("placeholder") || '';
	if (window.getLocalizedString) {
		placeHolder = getLocalizedString(placeHolder);
		numberField.setAttribute("placeholder", placeHolder);
	}

	// XMLHttpRequest
	httpReq = new XMLHttpRequest();
	httpReq.onreadystatechange = processReqChange;
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed

	// 最後の問い合わせから 15 分以上経過していたら再問い合わせする
	var now = (new Date).getTime();
	if ((0 < lastCheckTime) && (lastCheckTime + 15*60*1000 < now))
		formEdited();
}

// フォームからの入力
function formEdited() {
	var input = document.getElementById("numberfield").value;
	var number, bit, drn;

	if (input != "") {
		number = input.replace(/[^0-9]/g, "");

		// アロー便チェック : 11 桁且つ先頭が"8"の場合、無条件に OK とする
		if (number.length == 11) {
			number = "0" + number;
			if (Number(number.substr(1,1) == 8)) {
				inquiry(number);
				return true;
			}
		}

		if (number.length == 12) {
			// セブン DR チェック
			bit = Number(number.substr(11,1));
			drn = Number(number.substr(0,11)) % 7;
			if (bit == drn) {
				inquiry(number);
				return true;
			}
		}

		displayStatus("Wrong number.");
		return false;
	}
}

// 問い合わせ開始
function inquiry(number) {
	var now = (new Date).getTime();
	var uri = pelicanURI + "list.php?regist=%8C%9F%8D%F5%8AJ%8En";	// "検索開始" @ Shift_JIS

	lastCheckTime = now;
	displayStatus("Loading...");

	// HTTPリクエスト（非同期読み込み）
	httpReq.open("POST", uri, true);
	httpReq.setRequestHeader("Referer", "http://www.nittsu.co.jp/pelican/noflash.htm");
	httpReq.send("arr1=" + number);
}

// リクエスト状態（readyState）が変わったときに呼び出される
function processReqChange() {
	var buffer = new Array();
	var httpHeader = "";
	var htmlDoc = "";
	var i;

	if (httpReq.readyState == 4) { // readyState 4 = complete
		if (httpReq.status == 200) {						// 200:ダウンロード成功
			httpHeader = httpReq.getAllResponseHeaders();	// レスポンスヘッダ
			htmlDoc = httpReq.responseText;					// HTMLソース
			parseHTML(htmlDoc);
		}
	}
}

// HTML から情報を取り出す
function parseHTML(htmlDoc) {
	var buffer = "";
	var index = 0;
	var number = ""
	var status = ""
	var detailHref = "";

	// 伝票番号と詳細情報へのリンク
	if (htmlDoc.match(/<a href="\.\/(detail\.php[^"]*)">([^<]+)<\/a>/)) {		// "
		detailHref = pelicanURI + RegExp.$1;
		buffer = RegExp.$2;
		if (buffer.match(/([0-9\-]+)/))
			number = RegExp.$1;

		// 全角スペース除去
		detailHref = detailHref.replace(RegExp(String.fromCharCode(0x3000),"g"), "");
	}

	// 配達状況
	buffer = "";
	index = htmlDoc.indexOf("<a href=\"./detail.php")
	if (0 <= index)
		buffer = htmlDoc.substr(index);

	index = buffer.indexOf("<td")
	if (0 <= index)
		buffer = buffer.substr(index);

	index = buffer.indexOf("</td>")
	if (0 <= index)
		buffer = buffer.substr(0, index);

	buffer = buffer.replace(/<[^>]+>/g, "");
	buffer = buffer.replace(RegExp(String.fromCharCode(0x3000),"g"), "");
	status = buffer.replace(/\n/g, "");

	// 情報表示
	if (number && status && detailHref)
		displayResult(number, status, detailHref);
	else
		displayStatus("Not found.");
}

// 情報表示
function displayResult(number, status, detailHref) {
	var result = document.getElementById("result");
	var anchor = document.createElement("span");

	document.getElementById("numberfield").value = number;
	result.innerHTML = status;
	anchor.innerText = number;
	anchor.setAttribute("onclick", "goDetail('" + detailHref + "');");
	anchor.setAttribute("class", "goDetail");
	anchor.setAttribute("title", "Show the detail with WWW browser");
	result.appendChild(anchor);
}

// エラー表示
function displayStatus(str) {
	CreateText("result", {text:str});
}

// WWW ブラウザで詳細を表示
function goDetail(uri) {
	goWWW(uri);
}

function goWidgetPage() {
	goWWW(widgetURI);
}

function goWWW(uri) {
	if (window.widget)
		widget.openURL(uri);
	else
		window.location.href = uri;
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}
